<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Crypt;

class SwitchDatabaseMiddleware
{
    public function handle($request, Closure $next)
    {

        $connectToken = null;
        $accessToken = null;

        // Get all post data
        $postData = $request->all();


        // Get Access Token from post data
        if (isset($postData['AccessToken'])) {
            $accessToken = $postData['AccessToken'];
        }

        // Get Access Token from query data if not set previously
        if (!$accessToken && $request->isMethod('get')) {
            $accessToken = $request->query('AccessToken');
        }

        // Get ConnectToken from post data
        if (isset($postData['ConnectToken'])) {
            $connectToken = $postData['ConnectToken'];
        }

        // Get ConnectToken from query data if not set previously
        if (!$connectToken && $request->isMethod('get')) {
            $connectToken = $request->query('ConnectToken');
        }



        // If connect token found
        if ($connectToken) {

            $tokenData = Crypt::decrypt($connectToken);
            $connectionString = $tokenData['Db']['DB_ConnectionURL'];

            // Define regular expressions to match URL and database name
            $urlPattern = '/jdbc:sqlserver:\/\/(.*?):(\d+);/';
            $databaseNamePattern = '/databaseName=(.*?)(;|$)/';

            // Match URL and port number
            preg_match($urlPattern, $connectionString, $urlMatches);
            $hostname = $urlMatches[1]; // Extract URL
            $port = $urlMatches[2]; // Extract port number

            // Match database name
            preg_match($databaseNamePattern, $connectionString, $databaseNameMatches);
            $databaseName = $databaseNameMatches[1]; // Extract database name

            $userId = $tokenData['Db']['DB_UserID'];
            // $password = "SA++2024**";
            $password = $tokenData['Db']['DB_Password'];

            // Your custom database configuration
            $customConfig = [
                'driver' => 'sqlsrv',
                'host' => $hostname,
                'port' => $port,
                'database' => $databaseName,
                'username' => $userId,
                'password' => $password,
                // Add other configuration parameters as needed
            ];

            // Change the database connection
            DB::purge('sqlsrv');
            config(['database.connections.sqlsrv' => $customConfig]);
            // DB::reconnect('sqlsrv');

        }

 //return response()->json(['status' => '0', 'error' => $customConfig, 'message' => 'Testing', 'oData' => []], 422);

        // dd([
        //     $accessToken,
        //     $connectToken
        //     ]);

        // if ($connectToken) {
        //     // Change the database connection
        //     config(['database.connections.sqlsrv.database' => $connectToken]);
        //     DB::purge('sqlsrv');
        //     DB::reconnect('sqlsrv');
        // }

        return $next($request);
    }
}
